# $Revision: 1.56 $, $Date: 2005/11/01 11:18:57 $
#
# Conditional build:
%bcond_with	bootstrap	# use foreign (non-rpm) ghc to bootstrap
#
Summary:	Glasgow Haskell Compilation system
Summary(pl):	System kompilacji Glasgow Haskell
Name:		ghc
Version:	6.4.1
Release:	2
License:	BSD-like w/o adv. clause
Group:		Development/Languages
Source0:	http://haskell.org/ghc/dist/%{version}/%{name}-%{version}-src.tar.bz2
# Source0-md5:	fd289bc7c3afa272ff831a71a50b5b00
Patch0:		%{name}-ac.patch
URL:		http://haskell.org/ghc/
BuildRequires:	alex >= 2.0
BuildRequires:	autoconf
BuildRequires:	docbook-style-dsssl
BuildRequires:	docbook-style-xsl
%{!?with_bootstrap:BuildRequires:	ghc >= 4.0.8}
BuildRequires:	gmp-devel
BuildRequires:	happy >= 1.10
BuildRequires:	jadetex
BuildRequires:	ncurses-devel
BuildRequires:	libxslt-progs
BuildRequires:	openjade
BuildRequires:	readline-devel
BuildRequires:	rpmbuild(macros) >= 1.213
BuildRequires:	sgml-common
BuildRequires:	tetex-dvips
BuildRequires:	tetex-format-latex
BuildRequires:	tetex-latex-bibtex
BuildRequires:	tetex-metafont
Provides:	haskell
# there is no more ghc ports in PLD
ExclusiveArch:	%{ix86} %{x8664} alpha ppc sparc
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The Glorious Glasgow Haskell Compilation System (GHC) is a robust,
fully-featured, optimising compiler for the functional programming
language Haskell 98. GHC compiles Haskell to either native code or C.
It implements numerous experimental language extensions to Haskell,
including concurrency, a foreign language interface, several
type-system extensions, exceptions, and so on. GHC comes with a
generational garbage collector, a space and time profiler, and a
comprehensive set of libraries. This package includes HTML and PS
versions of the SGML-based documentation for GHC. They are also
available online at http://www.haskell.org/ghc/.

Haskell 98 is "the" standard lazy functional programming language.
More info plus the language definition is at http://www.haskell.org/.

%description -l pl
Sawny Glasgow Haskell Compilation System (GHC) to mocny, w peni
funkcjonalny, optymalizujcy kompilator funkcyjnego jzyka
programowania Haskell 98. GHC kompiluje Haskella do kodu natywnego lub
do C. Ma zaimplementowanych wiele eksperymentalnych rozszerze jzyka,
w tym wspbieno, interfejs do innych jzykw, rozszerzenia systemu
typw, wyjtki itd. GHC zawiera garbage collector, profiler, obszerny
zestaw bibliotek. Ten pakiet zawiera wersje HTML i PostScriptow
dokumentacji bazowanej na SGML-u. S one dostpne take online pod
<http://www.haskell.org/ghc/>.

Haskell 98 to standardowy leniwy funkcyjny jzyk programowania. Wicej
informacji oraz definicja jzyka pod <http://www.haskell.org/>.

%package prof
Summary:	Profiling libraries for GHC
Summary(pl):	Biblioteki profilujce dla GHC
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description prof
Profiling libraries for Glorious Glasgow Haskell Compilation System
(GHC). They should be installed when GHC's profiling subsystem is
needed.

%description prof -l pl
Biblioteki profilujce dla GHC. Powinny by zainstalowane kiedy
potrzebujemy systemu profilujcego z GHC.

%prep
%setup -q
%patch0 -p1

# generate our own `build.mk'
#
# * this is a kludge
#
cat >mk/build.mk <<END
GhcLibWays = p
SRC_HAPPY_OPTS += -agc # useful from Happy 1.7 onwards
SRC_HAPPY_OPTS += -c
END
%ifarch %{x8664} alpha sparc
cat >>mk/build.mk <<END 
GhcUnregisterised=YES
END
%endif
%ifarch %{x8664} alpha ppc sparc
cat >>mk/build.mk <<END 
SplitObjs=NO
END
%endif

%build
cp -f /usr/share/automake/config.sub .
%{__autoconf}
%configure \
	--with-gcc="%{__cc}" \
	--disable-openal

%{__make} boot
%{__make} -C glafp-utils sgmlverb
%{__make} all
%{__make} -C docs html
%{__make} -C ghc/docs html
%{__make} -C hslibs/doc html

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install-dirs install \
	bindir=$RPM_BUILD_ROOT%{_bindir} \
	prefix=$RPM_BUILD_ROOT%{_prefix} \
	libdir=$RPM_BUILD_ROOT%{_libdir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc ghc/{ANNOUNCE,README}
%doc ghc/docs/users_guide/users_guide
%doc hslibs/doc/hslibs
%attr(755,root,root) %{_bindir}/*
%{_libdir}/ghc-%{version}/icons
%dir %{_libdir}/ghc-%{version}
%{_libdir}/ghc-%{version}/include
%{_libdir}/ghc-%{version}/imports
%exclude %{_libdir}/ghc-%{version}/imports/*.p_hi
%exclude %{_libdir}/ghc-%{version}/imports/*/*.p_hi
%exclude %{_libdir}/ghc-%{version}/imports/*/*/*.p_hi
%exclude %{_libdir}/ghc-%{version}/imports/*/*/*/*.p_hi
%{_libdir}/ghc-%{version}/hslibs-imports
%exclude %{_libdir}/ghc-%{version}/hslibs-imports/*/*.p_hi
%attr(755,root,root) %{_libdir}/ghc-%{version}/cgprof
%attr(755,root,root) %{_libdir}/ghc-%{version}/ghc-%{version}
%attr(755,root,root) %{_libdir}/ghc-%{version}/ghc-asm
%attr(755,root,root) %{_libdir}/ghc-%{version}/ghc-pkg.bin
%attr(755,root,root) %{_libdir}/ghc-%{version}/ghc-split
%attr(755,root,root) %{_libdir}/ghc-%{version}/hsc2hs-bin
%attr(755,root,root) %{_libdir}/ghc-%{version}/unlit
%{_libdir}/ghc-%{version}/*.prl
%{_libdir}/ghc-%{version}/libHS*[!p].a
%ifarch %{ix86} %{x8664} ppc ppc64 sparc sparcv9 sparc64
%{_libdir}/ghc-%{version}/HS*.o
%endif
%{_libdir}/ghc-%{version}/package.conf
%{_libdir}/ghc-%{version}/*.h
%{_libdir}/ghc-%{version}/ghc*-usage.txt

%files prof
%defattr(644,root,root,755)
%{_libdir}/ghc-%{version}/imports/*.p_hi
%{_libdir}/ghc-%{version}/imports/*/*.p_hi
%{_libdir}/ghc-%{version}/imports/*/*/*.p_hi
%{_libdir}/ghc-%{version}/imports/*/*/*/*.p_hi
%{_libdir}/ghc-%{version}/hslibs-imports/*/*.p_hi
%{_libdir}/ghc-%{version}/libHS*_p.a

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: ghc.spec,v $
Revision 1.56  2005/11/01 11:18:57  arekm
- rel 2

Revision 1.55  2005/10/18 20:40:42  arekm
- add BR: docbook-style-xsl

Revision 1.54  2005/10/18 07:37:09  qboosh
- updated files (only archs with ghci have HS*.o); builds on alpha now
- don't package *.p_hi twice

Revision 1.53  2005/10/18 06:13:03  arekm
- BR: libxslt-progs

Revision 1.52  2005/10/17 12:41:08  qboosh
- added bootstrap bcond, fixed shellglob

Revision 1.51  2005/10/17 09:05:52  arekm
- up to 6.4.1

Revision 1.50  2005/09/18 18:07:12  arekm
- rel 2

Revision 1.49  2005/09/18 18:03:46  arekm
- fix powerpc build

Revision 1.48  2005/09/17 10:37:00  arekm
- rel 1

Revision 1.47  2005/07/04 21:18:19  qboosh
- x8664 macro includes amd64

Revision 1.46  2005/07/03 19:59:09  undefine
- up to 6.4
- some cleanup
- use html docs
- not tested on all archs - rel 0.1

Revision 1.45  2005/05/11 15:27:01  qboosh
- use x8664 macro

Revision 1.44  2005/05/01 18:02:05  glen
- %description url unification
  find -name '*.spec' | xargs -l1024 sed -i -e 's#\(http://.\+/\) \.#<\1>.#g'

Revision 1.43  2005/03/22 14:24:14  zboczuch
- typo in pl desc

Revision 1.42  2004/12/05 12:57:21  qboosh
- alpha must be unregisterised (mangler can't deal with modern binutils)

Revision 1.41  2004/12/01 23:00:58  qboosh
- BR: tetex-metafont

Revision 1.40  2004/12/01 08:12:49  undefine
- specify all directories, release 3

Revision 1.39  2004/12/01 06:18:08  undefine
- release 2 to rebuild with new generated ghc/alex/happy

Revision 1.38  2004/11/30 00:37:23  undefine
- release 1, exclusivearch: ix86/amd64/ppc/sparc.
- alpha is still missing, but i have no idea how to compile it there

Revision 1.37  2004/11/29 21:48:01  undefine
- disable object split on ppc. ppc works ;)

Revision 1.36  2004/11/27 13:16:53  qboosh
- __cc fix, BR: tetex-dvips

Revision 1.35  2004/11/24 08:01:56  undefine
- use unregistered on sparc too. probably on others archs will be similary

Revision 1.34  2004/11/24 08:00:26  undefine
- kill subshell

Revision 1.33  2004/11/23 20:50:46  undefine
- BR: tetex-format-latex

Revision 1.32  2004/11/23 09:44:28  undefine
- amd64 port:
  - disable splited object
  - only unregistered builds
- works, and compile yourself

Revision 1.31  2004/11/22 16:52:25  undefine
- up to 6.2.2, rel 0.1

Revision 1.30  2004/06/10 17:12:45  arekm
- ups

Revision 1.29  2004/06/10 17:11:48  arekm
- icons in datadir

Revision 1.28  2004/06/10 14:51:21  arekm
- our ar doesn't support -input and returns 0 even for bad options

Revision 1.27  2004/06/10 09:25:27  arekm
- trying to update to 6.2.1

Revision 1.26  2004/06/10 09:03:46  arekm
- apply debian patch

Revision 1.25  2004/06/10 07:18:50  zboczuch
- pl fix

Revision 1.24  2004/06/10 01:14:56  arekm
- just autoconf

Revision 1.23  2004/06/10 01:11:42  arekm
- other archs support

Revision 1.22  2004/03/01 12:50:26  baggins
- finished update to 6.2

Revision 1.21  2004/02/24 01:11:55  ankry
- pl fixes, cosmetics

Revision 1.20  2004/02/17 16:06:05  baggins
- started update to 6.2

Revision 1.19  2003/05/26 16:25:01  malekith
- massive attack: adding Source-md5

Revision 1.18  2003/05/25 05:47:51  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.17  2003/02/28 10:07:55  trojan
- massive attack: perl -pi -e "s/^#+\%\{/#\%\%\{/"

Revision 1.16  2002/10/07 11:23:57  qboosh
- BR: autoconf; new %%doc

Revision 1.15  2002/05/21 23:13:09  kloczek
perl -pi -e "s/^automake -a -c -f --foreing/\%\{__automake\}/; \
             s/^automake -a -c -f/\%\{__automake\}/; \
	     s/^autoconf/\%\{__autoconf\}/"

Revision 1.14  2002/04/25 16:23:03  arturs
fixed a small typo

Revision 1.13  2002/03/27 12:06:17  roman
s/BSD style/BSD-like in License

Revision 1.12  2002/02/23 02:17:44  kloczek
- adapterized.

Revision 1.11  2002/02/22 23:28:56  kloczek
- removed all Group fields translations (our rpm now can handle translating
  Group field using gettext).

Revision 1.10  2002/01/18 02:13:02  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.9  2001/12/04 23:53:52  filon
- updated to 5.02.1
- added buildrequires
- updated DESTDIR patch
- use autoconf now
- changes/fixes in docs and files
- pass %%{__cc} as gcc for confiugre script
- cleanup

Revision 1.8  2001/11/29 08:41:28  qboosh
- adapterized, pl translations, removed empty %%doc line; release 2

Revision 1.7  2001/09/25 19:40:13  pawelk
added some missing files

Revision 1.6  2001/09/18 17:49:10  baggins
- buildrequires happy >= 1.9

Revision 1.5  2001/08/06 18:23:42  pawelk
it works, it works ! (at least is seems to)

Revision 1.4  2001/06/26 15:23:32  pawelk
do 'make install' before 'make install-dirs'
NFY

Revision 1.3  2001/06/25 17:17:49  pawelk
version 5.00.2

Revision 1.2  2001/06/24 22:17:15  pawelk
-version 5.00.1
 i've started building it 6h30m ago and it's stil building on by
 k6-2/300, so i'm not sure if this is correct (but I hope so)

Revision 1.1  2000/11/20 12:53:53  baggins
- initial revision
